-- Xm and Xp are X(1) and X(0)
-- Ym and Yp are Y(1) and Y(0)
-- Zm and Zp are Z(1) and Z(0)
-- Data representation : Xp-Xm
-- with 00--> 0, 11--> 1, 01--> +1, 10--> -1

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.libarray.all;

entity sD_adder is 
port ( clk,rst : in std_logic;
		 x,y : in std_logic_vector(1 downto 0); --Check top comments
		 z : out std_logic_vector(1 downto 0)
		);
end sD_adder;

architecture cSadd of sD_adder is
signal sig_xm : std_logic;
signal sig_zp, sig_zm : std_logic;
signal n_sig_xm, n_sig_ym, n_sig_w2m,n_sig_g2p,n_sig_g2m,n_sig_g3 : std_logic;
signal sig_g3, sig_h2, sig_w2m : std_logic;
signal sig_g2p, sig_g2m, sig_w2p : std_logic;
signal sig_z2p,sig_z2m : std_logic;

begin

	n_sig_xm <= not(x(1));
	
	FA_add1: entity work.add_sig 
	port map( a => x(0),
				 b => n_sig_xm,
				 cin => y(0),
				 sum => sig_g3,
				 cout => sig_h2);
				 
	reg_ff1: entity work.d_ff 
	port map( clk=>clk,
				 rst=>rst,
				 d=>y(1),
				 q=>sig_g2p
				);
				
	
	
	reg_ff2: entity work.d_ff 
	port map( clk=>clk,
				 rst=>rst,
				 d=>sig_g3,
				 q=>sig_g2m
				);	
				
			
	n_sig_g2p <= not(sig_g2p);	

	FA_add2: entity work.add_sig 
	port map( a => sig_g2m,
				 b => n_sig_g2p,
				 cin => sig_h2,
				 sum => sig_w2p,
				 cout => sig_w2m);
				 
	n_sig_w2m <= not(sig_w2m);
	
	reg_ff3: entity work.d_ff 
	port map( clk=>clk,
				 rst=>rst,
				 d=>sig_w2p,
				 q=>sig_z2p
				);
				
	reg_ff4: entity work.d_ff 
	port map( clk=>clk,
				 rst=>rst,
				 d=>sig_z2p,
				 q=>z(0)
				);
							
	reg_ff5: entity work.d_ff 
	port map( clk=>clk,
				 rst=>rst,
				 d=>n_sig_w2m,
				 q=>z(1)
				);
end cSadd;
